//! Re-exports Makefile defines as more usable types
#ifndef _PROJECT_H
#define _PROJECT_H

#include "macros.h"
#include "ints.h"
#include "version.h"

/// Project version, as a raw version identifier (u32).
/// Use `v_rawtoc()` to convert to `version_t`.
#define PROG_VERSION VERSION(_VERSION_MAJOR, \
				_VERSION_MINOR, \
				_VERSION_BUGFIX, \
				_VERSION_REVISION)

/// Project name. Output binary name
#define PROG_NAME _PROJECT_NAME
/// Project description
#define PROG_DESCRIPTION _PROJECT_DESCRIPTION
/// Project authour(s)
#define PROG_AUTHOUR _PROJECT_AUTHOR
/// Project license
#define PROG_LICENSE _PROJECT_LICENSE
/// Compiled time (UTC unix timestamp)
#define PROG_COMPILED_TIMESTAMP AS(_PROJECT_COMPILED, u64)

#endif /* _PROJECT_H */
